<?php
/**
 * @category   Newsroom
 * @package    Newsroom_Presskit
 * @author     dushyantjoshia@gmail.com
 * @copyright  This file was generated by using Module Creator(http://code.vky.co.in/magento-2-module-creator/) provided by VKY <viky.031290@gmail.com>
 * @license    http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
 */

namespace Newsroom\Presskit\Controller\Adminhtml\Items;

class Save extends \Newsroom\Presskit\Controller\Adminhtml\Items {
	public function execute() {
		if ($this->getRequest()->getPostValue()) {
			try {
				$model = $this->_objectManager->create('Newsroom\Presskit\Model\Presskit');

				$data = $this->getRequest()->getPostValue();
				/*			echo "<pre>";
					print_r($data);
				*/
				$nfiles = '';
				$newimages = [];
				if (isset($_FILES)) {
					$i = 0;

					$files = $this->getRequest()->getFiles('image');
					if (isset($_FILES['base_image']['name']) && $_FILES['base_image']['name'] != '') {
						try {
							$uploaderFactory = $this->uploaderFactory->create(['fileId' => 'base_image']);
							$uploaderFactory->setAllowedExtensions(['jpg', 'jpeg', 'gif', 'png']);
							$imageAdapter = $this->adapterFactory->create();
							$uploaderFactory->addValidateCallback('custom_image_upload', $imageAdapter, 'validateUploadFile');
							$uploaderFactory->setAllowRenameFiles(true);
							$uploaderFactory->setFilesDispersion(true);
							$mediaDirectory = $this->filesystem->getDirectoryRead($this->directoryList::MEDIA);
							$destinationPath = $mediaDirectory->getAbsolutePath('newsroom/presskit');
							$result = $uploaderFactory->save($destinationPath);
							if (!$result) {
								throw new LocalizedException(
									__('File cannot be saved to path: $1', $destinationPath)
								);
							}

							$imagePath = 'newsroom/presskit' . $result['file'];
							$data['base_image'] = $imagePath;
						} catch (\Exception $e) {
						}
					}
					$imagePath = '';
					foreach ($files as $file) {
						try {
							$uploaderFactory = $this->uploaderFactory->create(["fileId" => "image[$i]"]);
							$uploaderFactory->setAllowedExtensions(['jpg', 'jpeg', 'gif', 'png']);
							$imageAdapter = $this->adapterFactory->create();
							$uploaderFactory->addValidateCallback('custom_image_upload', $imageAdapter, 'validateUploadFile');
							$uploaderFactory->setAllowRenameFiles(true);
							$uploaderFactory->setFilesDispersion(true);
							$mediaDirectory = $this->filesystem->getDirectoryRead($this->directoryList::MEDIA);
							$destinationPath = $mediaDirectory->getAbsolutePath('newsroom/presskit');
							$result = $uploaderFactory->save($destinationPath);
							if (!$result) {
								throw new LocalizedException(
									__('File cannot be saved to path: $1', $destinationPath)
								);
							}

							$imagePath = 'newsroom/presskit' . $result['file'];
							$newimages[] = $imagePath;
							$nfiles = $nfiles . ',' . $imagePath;
						} catch (\Exception $e) {
						}
						$i++;
					}
					/*$data['image'] = trim($nfiles, ',');*/
				}

				if (isset($data['presskit_remove_image'])) {
					foreach ($data['presskit_remove_image'] as $imageId => $value) {
						$imageModel = $this->_objectManager->create('Newsroom\Presskit\Model\Image');
						$imageModel->load($imageId);
						$imageModel->delete();
					}

				}

				if (isset($data['base_image']['delete']) && $data['base_image']['delete'] == 1) {
					$mediaDirectory = $this->filesystem->getDirectoryRead($this->directoryList::MEDIA)->getAbsolutePath();
					$file = $data['base_image']['value'];
					$imgPath = $mediaDirectory . $file;
					if ($this->_file->isExists($imgPath)) {
						$this->_file->deleteFile($imgPath);
					}
					$data['base_image'] = NULL;
				}
				if (isset($data['base_image']['value'])) {
					$data['base_image'] = $data['base_image']['value'];
				}
				$inputFilter = new \Zend_Filter_Input(
					[],
					[],
					$data
				);
				$data = $inputFilter->getUnescaped();
				$id = $this->getRequest()->getParam('id');
				if ($id) {
					$model->load($id);
					if ($id != $model->getId()) {
						throw new \Magento\Framework\Exception\LocalizedException(__('The wrong item is specified.'));
					}
				}
				$model->setData($data);
				$session = $this->_objectManager->get('Magento\Backend\Model\Session');
				$session->setPageData($model->getData());
				$model->save();

				foreach ($newimages as $dataImage) {
					$imageModel = $this->_objectManager->create('Newsroom\Presskit\Model\Image');
					$imageModel->setPresskitId($model->getId());
					$imageModel->setImages($dataImage);
					$imageModel->save();
				}

				$this->messageManager->addSuccess(__('You saved the item.'));
				$session->setPageData(false);
				if ($this->getRequest()->getParam('back')) {
					$this->_redirect('newsroom_presskit/*/edit', ['id' => $model->getId()]);
					return;
				}
				$this->_redirect('newsroom_presskit/*/');
				return;
			} catch (\Magento\Framework\Exception\LocalizedException $e) {
				$this->messageManager->addError($e->getMessage());
				$id = (int) $this->getRequest()->getParam('id');
				if (!empty($id)) {
					$this->_redirect('newsroom_presskit/*/edit', ['id' => $id]);
				} else {
					$this->_redirect('newsroom_presskit/*/new');
				}
				return;
			} catch (\Exception $e) {
				$this->messageManager->addError(
					__('Something went wrong while saving the item data. Please review the error log.')
				);
				$this->_objectManager->get('Psr\Log\LoggerInterface')->critical($e);
				$this->_objectManager->get('Magento\Backend\Model\Session')->setPageData($data);
				$this->_redirect('newsroom_presskit/*/edit', ['id' => $this->getRequest()->getParam('id')]);
				return;
			}
		}
		$this->_redirect('newsroom_presskit/*/');
	}
}
